﻿<%@ WebHandler Language="C#" Class="UploadifyUpload" %>

using System;
using System.Collections;
using System.Data;
using System.Web;
using System.Linq;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.SessionState;
using System.IO;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;

public class UploadifyUpload : IHttpHandler, IRequiresSessionState
{

    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = "text/plain";
        context.Response.Charset = "utf-8";

        string action = context.Request["action"];
        switch (action)
        {
            case "upload":
                //上传图片
                upload(context);
                break;
            case "cutsaveimg":
                //裁剪并保存
                cutsaveimg(context);
                break;
        }
        context.Response.End();
    }

    /// <summary>
    /// 上传图片
    /// </summary>
    /// <param name="context"></param>
    private void upload(HttpContext context)
    {
        HttpPostedFile postedFile = context.Request.Files["Filedata"];
        if (postedFile != null)
        {
            string fileName, fileExtension;
            int fileSize;
            fileName = postedFile.FileName;
            fileSize = postedFile.ContentLength;
            if (fileName != "")
            {

                fileExtension = postedFile.FileName.Substring(postedFile.FileName.LastIndexOf('.'));
                string strPath = context.Server.MapPath("/") + "\\App_File\\Upload\\";//设置文件的路径
                string strFileName = "upload" + DateTime.Now.ToString("yyyyMMddHHmmss") + fileExtension;
                string strFileUrl = strPath + strFileName;//保存文件路径
                if (!Directory.Exists(strPath))
                {
                    Directory.CreateDirectory(strPath);
                }
                postedFile.SaveAs(strFileUrl);//先保存源文件

                context.Response.Write("{\"status\":0,\"message\":\"/App_File/Upload/" + strFileName + "\"}");
            }
            else
            {
                context.Response.Write("{\"status\":1,\"message\":\"上传失败！\"}");
            }
        }
        else
        {
            context.Response.Write("{\"status\":1,\"message\":\"上传失败！\"}");
        }
    }

    /// <summary>
    /// 裁剪并保存图片
    /// </summary>
    /// <param name="context"></param>
    private void cutsaveimg(HttpContext context)
    {
        string strImgUrl = context.Request["strImgUrl"];
        string strXone = context.Request["hidXone"];
        string strYone = context.Request["hidYone"];
        string strImgWidth = context.Request["hidImgWidth"];
        string strImgHeight = context.Request["hidImgHeight"];

        string[] urls = strImgUrl.Split('/');
        string str_url = urls.Last();

        try
        {
            string strOldFiel = context.Server.MapPath("~/App_File/Upload/");
            string strNewFiel = context.Server.MapPath("~/App_File/Cut/");
            string strOldUrl = Path.Combine(strOldFiel, str_url);
            string strNewUrl = Path.Combine(strNewFiel, "cut" + DateTime.Now.ToString("yyyyMMddHHmmss") + "." + str_url.Split('.')[1]);
            if (!Directory.Exists(strNewFiel))
            {
                Directory.CreateDirectory(strNewFiel);
            }
            int intStartX = int.Parse(strXone);
            int intStartY = int.Parse(strYone);
            int intWidth = int.Parse(strImgWidth);
            int intHeight = int.Parse(strImgHeight);
            CutGeneratedImage(intStartX, intStartY, intWidth, intHeight, strOldUrl, strNewUrl);
            context.Response.Write("{\"status\":0,\"message\":\"裁剪成功并保存！\"}");
        }
        catch
        {
            context.Response.Write("{\"status\":1,\"message\":\"裁剪失败！\"}");
        }
    }
    /// <summary>
    /// 裁剪图片
    /// </summary>
    /// <param name="intWidth">要缩小裁剪图片宽度</param>
    /// <param name="intHeight">要缩小裁剪图片长度</param>
    /// <param name="strOldImgUrl">要处理图片路径</param>
    /// <param name="strNewImgUrl">处理完毕图片路径</param>
    public void CutGeneratedImage(int intStartX, int intStartY, int intWidth, int intHeight, string strOldImgUrl, string strNewImgUrl)
    {
        //上传标准图大小
        int intStandardWidth = 120;
        int intStandardHeight = 120;

        int intReduceWidth = 0; // 缩小的宽度
        int intReduceHeight = 0; // 缩小的高度
        int intCutOutWidth = 0; // 裁剪的宽度
        int intCutOutHeight = 0; // 裁剪的高度
        int level = 100; //缩略图的质量 1-100的范围

        //获得缩小，裁剪大小
        if (intStandardHeight * intWidth / intStandardWidth > intHeight)
        {
            intReduceWidth = intWidth;
            intReduceHeight = intStandardHeight * intWidth / intStandardWidth;
            intCutOutWidth = intWidth;
            intCutOutHeight = intHeight;
        }
        else if (intStandardHeight * intWidth / intStandardWidth < intHeight)
        {
            intReduceWidth = intStandardWidth * intHeight / intStandardHeight;
            intReduceHeight = intHeight;
            intCutOutWidth = intWidth;
            intCutOutHeight = intHeight;
        }
        else
        {
            intReduceWidth = intWidth;
            intReduceHeight = intHeight;
            intCutOutWidth = intWidth;
            intCutOutHeight = intHeight;
        }

        //通过连接创建Image对象
        //System.Drawing.Image oldimage = System.Drawing.Image.FromFile(strOldImgUrl);
        //oldimage.Save(Server.MapPath("tepm.jpg"));
        //oldimage.Dispose();

        //缩小图片
        Bitmap bm = new Bitmap(strOldImgUrl);

        //处理JPG质量的函数
        ImageCodecInfo[] codecs = ImageCodecInfo.GetImageEncoders();
        ImageCodecInfo ici = null;
        foreach (ImageCodecInfo codec in codecs)
        {
            if (codec.MimeType == "image/jpeg")
            {
                ici = codec;
                break;
            }

        }
        EncoderParameters ep = new EncoderParameters();
        ep.Param[0] = new EncoderParameter(System.Drawing.Imaging.Encoder.Quality, (long)level);

        //裁剪图片
        Rectangle cloneRect = new Rectangle(intStartX, intStartY, intCutOutWidth, intCutOutHeight);
        PixelFormat format = bm.PixelFormat;
        Bitmap cloneBitmap = bm.Clone(cloneRect, format);

        //保存图片
        cloneBitmap.Save(strNewImgUrl, ici, ep);
        bm.Dispose();
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }
}